"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeboxTransformInterceptor = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const constants_js_1 = require("@nestjs/swagger/dist/constants.js");
const operators_1 = require("rxjs/operators");
const decorators_js_1 = require("./decorators.js");
let TypeboxTransformInterceptor = class TypeboxTransformInterceptor {
    reflector;
    constructor(reflector) {
        this.reflector = reflector;
    }
    intercept(context, next) {
        return next.handle().pipe((0, operators_1.map)(data => {
            const responseMeta = this.reflector.get(constants_js_1.DECORATORS.API_RESPONSE, context.getHandler()) ?? {};
            const validator = (responseMeta['200'] || responseMeta['201'] || {})['type'];
            if (!(0, decorators_js_1.isSchemaValidator)(validator)) {
                return data;
            }
            return validator.validate(data);
        }));
    }
};
exports.TypeboxTransformInterceptor = TypeboxTransformInterceptor;
exports.TypeboxTransformInterceptor = TypeboxTransformInterceptor = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.Reflector])
], TypeboxTransformInterceptor);
//# sourceMappingURL=interceptors.js.map